//symbol	period	price_date	opening_price	high_price	low_price	closing_price	adj_closing_price	volume	sma_5	sma_10	sma_20	sma_50	sma_100	sma_200	ema_5	ema_10	ema_20	ema_50	ema_100	ema_200	ema_12	ema_26	macd_12_26	macd_12_26_signal_9	macd_hist_12_26	ppo_12_26	ppo_12_26_signal_9	ppo_hist_12_26	rsi_14	rsi_20	rsi_30	stoch_fast_k_10_3	stoch_fast_d_10_3	stoch_slow_k_10_3	stoch_slow_d_10_3	stoch_fast_k_14_3	stoch_fast_d_14_3	stoch_slow_k_14_3	stoch_slow_d_14_3	vol_sma_5	vol_sma_10	vol_sma_20	vol_sma_50	vol_sma_100	vol_sma_200



#include "cmdline.h"
#include "printdata.h"
#include <mysql++.h>
#include <ssqls.h>
#include <fstream>
using namespace std;
// Breaks a given text line of tab-separated fields up into a list of
// strings.

sql_create_9(sp_500_sample,
	3, 9, // The meaning of these values is covered in the user manual
	mysqlpp::sql_char, symbol,
	mysqlpp::sql_char, period,
	mysqlpp::sql_date, price_date,
	mysqlpp::sql_double, opening_price,
	mysqlpp::sql_double, high_price,
	mysqlpp::sql_double, low_price,
	mysqlpp::sql_double, closing_price,
	mysqlpp::sql_double, adj_closing_price,
	mysqlpp::sql_double, volume)


static size_t
tokenize_line(const string& line, vector<mysqlpp::String>& strings)
{
    string field;
    strings.clear();
    istringstream iss(line);
    while (getline(iss, field, ','))
    {
        strings.push_back(mysqlpp::String(field));
    }
    return strings.size();
}
// Reads a tab-delimited text file, returning the data found therein
// as a vector of stock SSQLS objects.
static bool
read_stock_items(const char* filename, vector<sp_500_sample>& stock_vector)
{
    ifstream input(filename);
    if (!input)
    {
        cerr << "Error opening input file '" << filename << "'" << endl;
        return false;
    }
    string line;
    vector<mysqlpp::String> strings;
    int rowCounter = 0;
    while (getline(input, line))
    {
        int fieldNumber = tokenize_line(line, strings);
        if ( fieldNumber == 46)
        {
            mysqlpp::sql_char symbol , period;
            mysqlpp::sql_date price_date;
            mysqlpp::sql_double opening_price, high_price, low_price, closing_price, adj_closing_price, volume;

            symbol = string(strings[0]);
            period = string(strings[1]);
            price_date = strings[2];
            opening_price = strings[3];
            high_price =strings[4];
            low_price = strings[5];
            closing_price = strings[6];
            adj_closing_price = strings[7];
            volume = strings[8];

            stock_vector.push_back(sp_500_sample(symbol, period, price_date, opening_price, high_price, low_price,
                closing_price, adj_closing_price, volume));
        }
        else
        {
            cerr << "Error parsing input line (doesn't have 47 fields) " <<
            "in file '" << filename << "'" << " and has field number ="<<fieldNumber<< endl;
            cerr << "invalid line: '" << line << "'" << endl;
        }
        rowCounter ++;
    }
    return true;
}


static string
version_str(int packed)
{
    char buf[9];
    snprintf(buf, sizeof(buf), "%d.%d.%d",
             (packed & 0xFF0000) >> 16,
             (packed & 0x00FF00) >> 8,
             (packed & 0x0000FF));
    return buf;
}

int main(int argc, char *argv[])
{

    if (mysqlpp::get_library_version() != MYSQLPP_HEADER_VERSION)
    {
        cerr << "Version mismatch: library is v" <<
        version_str(mysqlpp::get_library_version()) <<
        ", headers are v" <<
        version_str(MYSQLPP_HEADER_VERSION) <<
        ".  Are you running this" << endl <<
        "with exrun?  See README.examples." << endl;
        return 1;
    }

    // Connect to database server
    const char *server = 0, *user = 0, *pass = "", *db = 0;
// Get database access parameters from command line
    if (parse_command_line(argc, argv, &db, &server, &user, &pass))
    {
        extern bool dtest_mode;
        if (dtest_mode)
        {
            cout << "Connecting to database server..." << endl;
        }
        else
        {
            cout << "Connecting to '" <<
            (user ? user : "USERNAME") << "'@'" <<
            (server ? server : "localhost") << "', with" <<
            (pass[0] ? "" : "out") << " password..." << endl;
        }
    }
    else
    {
        return 1;		// command line parsing failed
    }


#ifdef NICKTEST
// Read in a tab-delimited file of stock data
    try
    {
// Establish the connection to the database server.
        mysqlpp::Connection con(db, server, user, pass);
// Clear all existing rows from stock table, as we're about to
// insert a bunch of new ones, and we want a clean slate.
        print_table(con, "sp_500_sample");
    }
    catch (const mysqlpp::BadQuery& er)
    {
// Handle any query errors
        cerr << "Query error: " << er.what() << endl;
        return -1;
    }
    catch (const mysqlpp::BadConversion& er)
    {
// Handle bad conversions
        cerr << "Conversion error: " << er.what() << endl <<
        "\tretrieved data size: " << er.retrieved <<
        ", actual size: " << er.actual_size << endl;
        return -1;
    }
    catch (const mysqlpp::BadFieldName& er)
    {
// Handle bad conversions
        cerr << "BadFieldName error: " << er.what() << endl;
        return -1;
    }
    catch (const mysqlpp::Exception& er)
    {
// Catch-all for any other MySQL++ exceptions
        cerr << "Error: " << er.what() << endl;
        return -1;
    }
    return 0;
#else
// Read in a tab-delimited file of stock data
    vector<sp_500_sample> stock_vector;
    if (!read_stock_items("sp_500-11_2008_sample.csv", stock_vector))
    {
        return 1;
    }
    try
    {
// Establish the connection to the database server.
        mysqlpp::Connection con(db, server, user, pass);
// Clear all existing rows from stock table, as we're about to
// insert a bunch of new ones, and we want a clean slate.
        mysqlpp::Query query = con.query();
        query.exec("DELETE FROM sp_500_sample");
// Insert data read from the CSV file, allowing up to 1000
// characters per packet. We're using a small size in this
// example just to force multiple inserts. In a real program,
// you'd want to use larger packets, for greater efficiency.
        //mysqlpp::Query::MaxPacketInsertPolicy<> insert_policy(1000);
        cout<<"sample file has records of "<<stock_vector.size()<<endl;
        //vector<sp_500_sample>::iterator it;
        //it = stock_vector.begin();
        //it ++;
        query.insert(stock_vector.begin(), stock_vector.end()).execute();
        //query.insert(stock_vector.begin(), it);
        cout<<"insert rows: "<<query.affected_rows()<<"info:"<<query.info()<<endl;

// Retrieve and print out the new table contents.
        print_table(con, "sp_500_sample");
    }
    catch (const mysqlpp::BadQuery& er)
    {
// Handle any query errors
        cerr << "Query error: " << er.what() << endl;
        return -1;
    }
    catch (const mysqlpp::BadConversion& er)
    {
// Handle bad conversions
        cerr << "Conversion error: " << er.what() << endl <<
        "\tretrieved data size: " << er.retrieved <<
        ", actual size: " << er.actual_size << endl;
        return -1;
    }
    catch (const mysqlpp::BadFieldName& er)
    {
// Handle bad conversions
        cerr << "BadFieldName error: " << er.what() << endl;
        return -1;
    }
    catch (const mysqlpp::Exception& er)
    {
// Catch-all for any other MySQL++ exceptions
        cerr << "Error: " << er.what() << endl;
        return -1;
    }
    return 0;
#endif

}
